Parameter eq : forall (A:Type), A -> A -> Prop.
Axiom refl : forall A, forall (x:A), eq (A) x x.
Axiom eq_ind : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) x y) -> P y.
Definition eq_rect_r : forall A, forall (a:A), forall (x:A), (eq (A) x a) -> forall (P:(A -> Prop)), (P a) -> P x := fun (A:Type) => fun (a:A) => fun (x:A) => fun (p:eq (A) x a) => (((((((eq_ind) (A)) (x)) (fun (__:A) => forall (P:(A -> Prop)), (P __) -> P x)) (fun (P:A -> Prop) => fun (auto:P x) => (auto))) (a)) (p)).
Definition eq_ind_r : forall A, forall (a:A), forall (P:(A -> Prop)), (P a) -> forall (x:A), (eq (A) x a) -> P x := fun (A:Type) => fun (a:A) => fun (P:A -> Prop) => fun (p:P a) => (fun (x0:A) => fun (p0:eq (A) x0 a) => (((((((eq_rect_r) (A)) (a)) (x0)) (p0)) (fun (x01:A) => P x01)) (p))).
Definition rewrite_l : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) x y) -> P y := fun (A:Type) => fun (x:A) => fun (P:A -> Prop) => fun (Hx:P x) => (fun (y:A) => fun (Heq:eq (A) x y) => (((((((eq_ind) (A)) (x)) (fun (__:A) => P __)) (Hx)) (y)) (Heq))).
Definition sym_eq : forall A, forall (x:A), forall (y:A), (eq (A) x y) -> eq (A) y x := fun (A:Type) => fun (x:A) => fun (y:A) => fun (Heq:eq (A) x y) => (((((((rewrite_l) (A)) (x)) (fun (__:A) => eq (A) __ x)) (((refl) (A)) (x))) (y)) (((((((rewrite_l) (A)) (x)) (fun (__:A) => eq (A) x __)) (((refl) (A)) (x))) (y)) (Heq))).
Definition rewrite_r : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) y x) -> P y := fun (A:Type) => fun (x:A) => fun (P:A -> Prop) => fun (Hx:P x) => (fun (y:A) => fun (Heq:eq (A) y x) => (((((((eq_ind) (A)) (x)) (fun (__:A) => P __)) (Hx)) (y)) (((((sym_eq) (A)) (y)) (x)) (Heq)))).
Definition trans_eq : forall A, forall (x:A), forall (y:A), forall (z:A), (eq (A) x y) -> (eq (A) y z) -> eq (A) x z := fun (A:Type) => fun (x:A) => fun (y:A) => fun (z:A) => fun (H1:eq (A) x y) => (fun (H2:eq (A) y z) => (((((((eq_ind_r) (A)) (y)) (fun (x0:A) => eq (A) x0 z)) (((((((rewrite_l) (A)) (x)) (fun (__:A) => eq (A) __ z)) (((((((rewrite_l) (A)) (x)) (fun (__:A) => eq (A) x __)) (((refl) (A)) (x))) (z)) (((((((rewrite_r) (A)) (y)) (fun (__:A) => eq (A) __ z)) (H2)) (x)) (H1)))) (y)) (H1))) (x)) (H1))).
